
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef OBJECT_TIMESTAMPS_H
#define OBJECT_TIMESTAMPS_H

class ObjLifeCycle;
class OLog;

// holds various object (entity) timestamps
class ObjTimes {
	friend class ObjLifeCycle;

	public:
		ObjTimes() { reset(); }

		void reset();

		Time lmt() const { return theLmt; }
		Time exp() const { return theExp; }
		bool showLmt() const { return doShowLmt; }
		bool knownExp() const { return theExp >= 0; }

		void store(OLog &log) const;

	protected:
		Time theLmt;
		Time theExp;
		bool doShowLmt;
};

#endif
