
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "beep/RawBeepMsg.h"

RawBeepMsg::RawBeepMsg(Types aType): theType(aType), 
	theChannel(-1), theNo(-1), theSeqNo(-1), theAnsNo(-1) {
}

void RawBeepMsg::replyTo(const RawBeepMsg &msg) {
	channel(msg.channel());
}

const String &RawBeepMsg::typeStr() const {
	static const String TypeStrs[bmtEnd] = 
		{ 0, "MSG", "RPY", "ANS", "ERR", "NUL" };

	if (bmtNone < theType && theType < bmtEnd)
		return TypeStrs[theType];
	else
		return TypeStrs[bmtNone];
}
