
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BLOB_INDEX_H
#define PG_BLOB_INDEX_H

class ReportBlob;
class String;

// key->blob index with fast search method
class BlobIdx {
	public:
		typedef String Key;

	public:
		BlobIdx(int aCapacity = 0);

		void add(const ReportBlob *blob);
		const ReportBlob *find(const Key &key) const;

	protected:
		const ReportBlob *find(const Key &key, int &idx) const;
		bool stopAt(const Key &key, const ReportBlob *&blob, int idx) const;
		void grow();

	protected:
		Array<const ReportBlob *> theHash;
		int theCount; // hash slots occupied
};

#endif
