
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_LEVEL_TRACE_FIGURE_H
#define PG_LEVEL_TRACE_FIGURE_H

#include "xstd/String.h"
#include "loganalyzers/ReportTraceFigure.h"

class LevelStex;
class PhaseInfo;
class PhaseTrace;
class StatIntvlRec;

// creates level trace figure based on interval level stats
class LevelTraceFig: public ReportTraceFigure {
	public:
		typedef LevelStex Stex;

	public:
		LevelTraceFig();

		void stats(const Stex *aStex1, const Stex *aStex2, const PhaseInfo *phase);

	protected:
		virtual int createCtrlFile();
		virtual void setCtrlOptions();

		int dumpDataLines(const LevelStex *stex);
		int dumpDataLine(const LevelStex *stex, Time stamp, const StatIntvlRec &r);
		
	protected:
		const Stex *theStex1;
		const Stex *theStex2;
		const PhaseInfo *thePhase;
		const PhaseTrace *theTrace;
};

#endif
