
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_HOSTS_BASED_SYMBOL_H
#define PG_HOSTS_BASED_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/PglRecSym.h"
#include "xstd/NetAddr.h"

class NetAddrSym;
class ArraySym;

// base class for robot and server symbols
class HostsBasedSym: public RecSym {
	public:
		static String TheType;

	public:
		HostsBasedSym(const String &aType);
		HostsBasedSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		int hostCount() const;
		NetAddrSym *host(int idx) const;

		bool addresses(ArraySym &addrs) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
