
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_EXPRESSION_SYMBOL_H
#define PGL_EXPRESSION_SYMBOL_H

#include "xparser/SynSym.h"
#include "pgl/PglExprOper.h"

// base class for all kind of "expressions"
class ExpressionSym: public SynSym {
	public:
		typedef ExpressionOper Oper;

	public:
		static String TheType;

	public:
		ExpressionSym(const String &aType): SynSym(aType) {}

		// clone self and apply a given operator (unary or binary);
		// by default, complains about unsupported operation
		virtual ExpressionSym *unOper(const Oper &op) const;
		virtual ExpressionSym *bnOper(const Oper &op, const SynSym &exp) const;

		virtual bool isA(const String &type) const;

	protected:
		void checkDenom(int val) const;
		void checkDenom(double val) const;
};

#endif
