
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RUNTIME_DATA_FILTER_H
#define PG_RUNTIME_DATA_FILTER_H

#include "xstd/String.h"

class IOBuf;

// common interface for various message headers and content filters
template <class Producer>
class DataFilter {
	public:
		virtual ~DataFilter() {}

		virtual String id() const = 0; // name-dash-version
		virtual void describe(ostream &os) const = 0; // a brief description

		// in-place filtering
		virtual void apply(Producer &p, IOBuf &buf) = 0;
};

#endif
