
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_VISIBLE_SERVERS_H
#define PG_VISIBLE_SERVERS_H

class HostCfg;
class NetAddr;
class PubWorld;

// iterates all visible servers, returning their HostCfg objects
class ViservIterator {
	public:
		ViservIterator();

		bool atEnd() const;
		int viserv() const;
		HostCfg *host() const;
		const NetAddr &addr() const;
		PubWorld *pubWorld() const;

		ViservIterator &operator ++();
		void next();
	
	protected:
		void sync();

	protected:
		int theIdx;
};

#endif
