
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/gadgets.h"
#include "xml/XmlRenderer.h"
#include "xml/XmlText.h"

XmlText::XmlText() {
	configureStream(theBuf, 2);
}

XmlText::XmlText(const String &t) {
	configureStream(theBuf, 2);
	text(t);
}

String XmlText::text() const {
	String s;
	s.append(theBuf.str(), theBuf.pcount());
	ostrstreamFreeze(theBuf, false);
	return s;
}

XmlNode *XmlText::clone() const {
	XmlText *txt = new XmlText;
	txt->buf().write(theBuf.str(), theBuf.pcount());
	ostrstreamFreeze(theBuf, false);
	return txt;
}

const String &XmlText::name() const {
	static const String myName("<text>"); // no tag can have a name with "<"
	return myName;
}

ostream &XmlText::print(ostream &os, const String &pfx) const {
	(os << pfx).write(theBuf.str(), theBuf.pcount());
	ostrstreamFreeze(theBuf, false);
	return os;
}

void XmlText::render(XmlRenderer &r) const {
	const char *str = theBuf.str();
	ostrstreamFreeze(theBuf, false);
	r.renderText(str, theBuf.pcount());
}
