
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef XSTD_STRSTREAM_META_H
#define XSTD_STRSTREAM_META_H

// note: newer sstream uses std::string so we should not use it for now

#if defined(HAVE_STRSTREAM_H)
#	include <strstream.h>
#elif defined(HAVE_STRSTREA_H) /* MS file name limit */
#	include <strstrea.h>
#endif

#ifdef HAVE_OSTRSTREAMFREEZE
	inline
	void ostrstreamFreeze(ostrstream &os, bool be) {
		os.freeze(be);
	}
	inline
	void strstreamFreeze(strstream &os, bool be) {
		os.freeze(be);
	}
#else
	inline
	void ostrstreamFreeze(ostrstream &os, bool be) {
		os.rdbuf()->freeze(be);
	}
	inline
	void strstreamFreeze(strstream &os, bool be) {
		os.rdbuf()->freeze(be);
	}
#endif


#endif
